<?php
declare (strict_types = 1);

namespace app\index\model;

use app\common\model\AttachmentBaseModel;
use think\model\concern\SoftDelete;

/**
 * 附件模型
 * @mixin \think\Model
 */
class AttachmentModel extends AttachmentBaseModel
{
    // 启用软删除
    use SoftDelete;
    // 软删除时间字段名
    protected $deleteTime = 'deleted_at';

    // 设置JSON字段
    protected $json = ['attach'];
    // 设置JSON数据返回数组
    protected $jsonAssoc = true;

    // 附件名称搜索器
    public function searchNameAttr($query, $value, $data)
    {
        if (is_null($value)) {
            return;
        }
        $query->where('name', 'like', "%{$value}%");
    }

    // 所属语言范围查询
    public function scopeLanguage($query, $language)
    {
        $query->where('language_id', '=', $language);
    }

    // 所属分类范围查询
    public function scopeCategory($query, $category)
    {
        if (is_null($category)) {
            return;
        }
        $query->where('category_id', '=', $category);
    }
}
